diff --git a/python/pytest/_pytest/pytester.py b/python/pytest/_pytest/pytester.py
index faed7f581c..5966219e8f 100644
--- a/python/pytest/_pytest/pytester.py
+++ b/python/pytest/_pytest/pytester.py
@@ -1,4 +1,5 @@
 """ (disabled by default) support for testing pytest and pytest plugins. """
+from __future__ import print_function
 import codecs
 import gc
 import os
@@ -45,7 +46,7 @@ def pytest_configure(config):
             config.pluginmanager.register(checker)
 
 
-class LsofFdLeakChecker(object):
+class LsofFdLeakChecker:
     def get_open_files(self):
         out = self._exec_lsof()
         open_files = self._parse_lsof_output(out)
@@ -91,7 +92,7 @@ class LsofFdLeakChecker(object):
             gc.collect()
         lines2 = self.get_open_files()
 
-        new_fds = set([t[0] for t in lines2]) - set([t[0] for t in lines1])
+        new_fds = {t[0] for t in lines2} - {t[0] for t in lines1}
         leaked_files = [t for t in lines2 if t[0] in new_fds]
         if leaked_files:
             error = []
@@ -147,7 +148,7 @@ def anypython(request):
                 executable = py.path.local(executable)
                 if executable.check():
                     return executable
-        pytest.skip("no suitable %s found" % (name,))
+        pytest.skip("no suitable {} found".format(name))
     return executable
 
 # used at least by pytest-xdist plugin
@@ -232,7 +233,7 @@ class HookRecorder:
                     break
                 print_("NONAMEMATCH", name, "with", call)
             else:
-                pytest.fail("could not find %r check %r" % (name, check))
+                pytest.fail("could not find {!r} check {!r}".format(name, check))
 
     def popcall(self, name):
         __tracebackhide__ = True
@@ -240,7 +241,7 @@ class HookRecorder:
             if call._name == name:
                 del self.calls[i]
                 return call
-        lines = ["could not find call %r, in:" % (name,)]
+        lines = ["could not find call {!r}, in:".format(name)]
         lines.extend(["  %s" % str(x) for x in self.calls])
         pytest.fail("\n".join(lines))
 
@@ -327,7 +328,7 @@ def testdir(request, tmpdir_factory):
     return Testdir(request, tmpdir_factory)
 
 
-rex_outcome = re.compile("(\d+) ([\w-]+)")
+rex_outcome = re.compile(r"(\d+) ([\w-]+)")
 class RunResult:
     """The result of running a command.
 
@@ -418,7 +419,7 @@ class Testdir:
             self._runpytest_method = self.runpytest_subprocess
 
     def __repr__(self):
-        return "<Testdir %r>" % (self.tmpdir,)
+        return "<Testdir {!r}>".format(self.tmpdir)
 
     def finalize(self):
         """Clean up global state artifacts.
@@ -870,8 +871,8 @@ class Testdir:
 
         """
         env = os.environ.copy()
-        env['PYTHONPATH'] = os.pathsep.join(filter(None, [
-            str(os.getcwd()), env.get('PYTHONPATH', '')]))
+        env['PYTHONPATH'] = os.pathsep.join([_f for _f in [
+            str(os.getcwd()), env.get('PYTHONPATH', '')] if _f])
         kw['env'] = env
         return subprocess.Popen(cmdargs,
                                 stdout=stdout, stderr=stderr, **kw)
@@ -920,7 +921,7 @@ class Testdir:
             for line in lines:
                 py.builtin.print_(line, file=fp)
         except UnicodeEncodeError:
-            print("couldn't print to %s because of encoding" % (fp,))
+            print(("couldn't print to {} because of encoding".format(fp)))
 
     def _getpytestargs(self):
         # we cannot use "(sys.executable,script)"
@@ -977,7 +978,7 @@ class Testdir:
         """
         basetemp = self.tmpdir.mkdir("pexpect")
         invoke = " ".join(map(str, self._getpytestargs()))
-        cmd = "%s --basetemp=%s %s" % (invoke, basetemp, string)
+        cmd = "{} --basetemp={} {}".format(invoke, basetemp, string)
         return self.spawn(cmd, expect_timeout=expect_timeout)
 
     def spawn(self, cmd, expect_timeout=10.0):
@@ -1002,8 +1003,8 @@ def getdecoded(out):
         try:
             return out.decode("utf-8")
         except UnicodeDecodeError:
-            return "INTERNAL not-utf8-decodeable, truncated string:\n%s" % (
-                    py.io.saferepr(out),)
+            return "INTERNAL not-utf8-decodeable, truncated string:\n{}".format(
+                    py.io.saferepr(out))
 
 
 class LineComp:
@@ -1107,4 +1108,4 @@ class LineMatcher:
                     show("    and:", repr(nextline))
                 extralines.append(nextline)
             else:
-                pytest.fail("remains unmatched: %r, see stderr" % (line,))
+                pytest.fail("remains unmatched: {!r}, see stderr".format(line))
diff --git a/python/pytest/_pytest/python.py b/python/pytest/_pytest/python.py
index 21d78aea33..e22dc44a93 100644
--- a/python/pytest/_pytest/python.py
+++ b/python/pytest/_pytest/python.py
@@ -52,7 +52,7 @@ if  sys.version_info[:2] == (2, 6):
         something on __getattr__ calls (see #1035).
         Backport of https://hg.python.org/cpython/rev/35bf8f7a8edc
         """
-        return isinstance(object, (type, types.ClassType))
+        return isinstance(object, (type, type))
 
 def _has_positional_arg(func):
     return func.__code__.co_argcount
@@ -96,7 +96,7 @@ def getimfunc(func):
         return func.__func__
     except AttributeError:
         try:
-            return func.im_func
+            return func.__func__
         except AttributeError:
             return func
 
@@ -188,8 +188,8 @@ def pyobj_property(name):
         node = self.getparent(getattr(pytest, name))
         if node is not None:
             return node.obj
-    doc = "python %s object this node was collected from (can be None)." % (
-          name.lower(),)
+    doc = "python {} object this node was collected from (can be None).".format(
+          name.lower())
     return property(get, None, None, doc)
 
 
@@ -337,7 +337,7 @@ def is_generator(func):
         # assume them to not be generators
         return False
 
-class PyobjContext(object):
+class PyobjContext:
     module = pyobj_property("Module")
     cls = pyobj_property("Class")
     instance = pyobj_property("Instance")
@@ -602,7 +602,7 @@ class Module(pytest.File, PyCollector):
 
     def collect(self):
         self.session._fixturemanager.parsefactories(self)
-        return super(Module, self).collect()
+        return super().collect()
 
     def _importtestmodule(self):
         # we assume we are only called once per module
@@ -683,7 +683,7 @@ class Instance(PyCollector):
 
     def collect(self):
         self.session._fixturemanager.parsefactories(self)
-        return super(Instance, self).collect()
+        return super().collect()
 
     def newinstance(self):
         self.obj = self._getobj()
@@ -741,7 +741,7 @@ class FunctionMixin(PyobjMixin):
         if excinfo.errisinstance(pytest.fail.Exception):
             if not excinfo.value.pytrace:
                 return py._builtin._totext(excinfo.value)
-        return super(FunctionMixin, self)._repr_failure_py(excinfo,
+        return super()._repr_failure_py(excinfo,
             style=style)
 
     def repr_failure(self, excinfo, outerr=None):
@@ -821,7 +821,7 @@ def fillfixtures(function):
 
 _notexists = object()
 
-class CallSpec2(object):
+class CallSpec2:
     def __init__(self, metafunc):
         self.metafunc = metafunc
         self.funcargs = {}
@@ -861,7 +861,7 @@ class CallSpec2(object):
 
     @property
     def id(self):
-        return "-".join(map(str, filter(None, self._idlist)))
+        return "-".join(map(str, [_f for _f in self._idlist if _f]))
 
     def setmulti(self, valtypes, argnames, valset, id, keywords, scopenum,
                  param_index):
@@ -1127,7 +1127,7 @@ def _idval(val, argname, idx, idfn):
         return str(val)
     elif isclass(val) and hasattr(val, '__name__'):
         return val.__name__
-    elif _PY2 and isinstance(val, unicode):
+    elif _PY2 and isinstance(val, str):
         # special case for python 2: if a unicode string is
         # convertible to ascii, return it as an str() object instead
         try:
@@ -1318,9 +1318,9 @@ def raises(expected_exception, *args, **kwargs):
             func(*args[1:], **kwargs)
         except expected_exception:
             return _pytest._code.ExceptionInfo()
-    pytest.fail("DID NOT RAISE {0}".format(expected_exception))
+    pytest.fail("DID NOT RAISE {}".format(expected_exception))
 
-class RaisesContext(object):
+class RaisesContext:
     def __init__(self, expected_exception):
         self.expected_exception = expected_exception
         self.excinfo = None
@@ -1355,7 +1355,7 @@ class Function(FunctionMixin, pytest.Item, FuncargnamesCompatAttr):
     def __init__(self, name, parent, args=None, config=None,
                  callspec=None, callobj=NOTSET, keywords=None, session=None,
                  fixtureinfo=None):
-        super(Function, self).__init__(name, parent, config=config,
+        super().__init__(name, parent, config=config,
                                        session=session)
         self._args = args
         if callobj is not NOTSET:
@@ -1415,7 +1415,7 @@ class Function(FunctionMixin, pytest.Item, FuncargnamesCompatAttr):
         self.ihook.pytest_pyfunc_call(pyfuncitem=self)
 
     def setup(self):
-        super(Function, self).setup()
+        super().setup()
         fillfixtures(self)
 
 
@@ -1431,7 +1431,7 @@ def scopeproperty(name=None, doc=None):
         def provide(self):
             if func.__name__ in scope2props[self.scope]:
                 return func(self)
-            raise AttributeError("%s not available in %s-scoped context" % (
+            raise AttributeError("{} not available in {}-scoped context".format(
                 scopename, self.scope))
         return property(provide, None, None, func.__doc__)
     return decoratescope
@@ -1736,7 +1736,7 @@ class SubRequest(FixtureRequest):
         self._fixturemanager = request._fixturemanager
 
     def __repr__(self):
-        return "<SubRequest %r for %r>" % (self.fixturename, self._pyfuncitem)
+        return "<SubRequest {!r} for {!r}>".format(self.fixturename, self._pyfuncitem)
 
 
 class ScopeMismatchError(Exception):
@@ -1762,7 +1762,7 @@ class FixtureLookupError(LookupError):
         tblines = []
         addline = tblines.append
         stack = [self.request._pyfuncitem.obj]
-        stack.extend(map(lambda x: x.func, self.fixturestack))
+        stack.extend([x.func for x in self.fixturestack])
         msg = self.msg
         if msg is not None:
             # the last fixture raise an error, let's present
@@ -1772,11 +1772,11 @@ class FixtureLookupError(LookupError):
             fspath, lineno = getfslineno(function)
             try:
                 lines, _ = inspect.getsourcelines(get_real_func(function))
-            except (IOError, IndexError):
+            except (OSError, IndexError):
                 error_msg = "file %s, line %s: source code not available"
                 addline(error_msg % (fspath, lineno+1))
             else:
-                addline("file %s, line %s" % (fspath, lineno+1))
+                addline("file {}, line {}".format(fspath, lineno+1))
                 for i, line in enumerate(lines):
                     line = line.rstrip()
                     addline("  " + line)
@@ -1791,7 +1791,7 @@ class FixtureLookupError(LookupError):
                 faclist = list(fm._matchfactories(fixturedef, parentid))
                 if faclist:
                     available.append(name)
-            msg = "fixture %r not found" % (self.argname,)
+            msg = "fixture {!r} not found".format(self.argname)
             msg += "\n available fixtures: %s" %(", ".join(available),)
             msg += "\n use 'py.test --fixtures [testpath]' for help on them."
 
@@ -2023,7 +2023,7 @@ class FixtureManager:
 
 def fail_fixturefunc(fixturefunc, msg):
     fs, lineno = getfslineno(fixturefunc)
-    location = "%s:%s" % (fs, lineno+1)
+    location = "{}:{}".format(fs, lineno+1)
     source = _pytest._code.Source(fixturefunc)
     pytest.fail(msg + ":\n\n" + str(source.indent()) + "\n" + location,
                 pytrace=False)
diff --git a/python/pytest/_pytest/recwarn.py b/python/pytest/_pytest/recwarn.py
index a89474c036..6cecb5e8ee 100644
--- a/python/pytest/_pytest/recwarn.py
+++ b/python/pytest/_pytest/recwarn.py
@@ -71,7 +71,7 @@ def deprecated_call(func=None, *args, **kwargs):
     deprecation_categories = (DeprecationWarning, PendingDeprecationWarning)
     if not any(issubclass(c, deprecation_categories) for c in categories):
         __tracebackhide__ = True
-        raise AssertionError("%r did not produce DeprecationWarning" % (func,))
+        raise AssertionError("{!r} did not produce DeprecationWarning".format(func))
     return ret
 
 
@@ -110,7 +110,7 @@ def warns(expected_warning, *args, **kwargs):
             return func(*args[1:], **kwargs)
 
 
-class RecordedWarning(object):
+class RecordedWarning:
     def __init__(self, message, category, filename, lineno, file, line):
         self.message = message
         self.category = category
@@ -120,7 +120,7 @@ class RecordedWarning(object):
         self.line = line
 
 
-class WarningsRecorder(object):
+class WarningsRecorder:
     """A context manager to record raised warnings.
 
     Adapted from `warnings.catch_warnings`.
@@ -195,7 +195,7 @@ class WarningsRecorder(object):
 
 class WarningsChecker(WarningsRecorder):
     def __init__(self, expected_warning=None, module=None):
-        super(WarningsChecker, self).__init__(module=module)
+        super().__init__(module=module)
 
         msg = ("exceptions must be old-style classes or "
                "derived from Warning, not %s")
@@ -211,7 +211,7 @@ class WarningsChecker(WarningsRecorder):
         self.expected_warning = expected_warning
 
     def __exit__(self, *exc_info):
-        super(WarningsChecker, self).__exit__(*exc_info)
+        super().__exit__(*exc_info)
 
         # only check if we're not currently handling an exception
         if all(a is None for a in exc_info):
diff --git a/python/pytest/_pytest/resultlog.py b/python/pytest/_pytest/resultlog.py
index 3670f0214c..1d963adba8 100644
--- a/python/pytest/_pytest/resultlog.py
+++ b/python/pytest/_pytest/resultlog.py
@@ -52,13 +52,13 @@ def generic_path(item):
         fspath = newfspath
     return ''.join(gpath)
 
-class ResultLog(object):
+class ResultLog:
     def __init__(self, config, logfile):
         self.config = config
         self.logfile = logfile # preferably line buffered
 
     def write_log_entry(self, testpath, lettercode, longrepr):
-        py.builtin.print_("%s %s" % (lettercode, testpath), file=self.logfile)
+        py.builtin.print_("{} {}".format(lettercode, testpath), file=self.logfile)
         for line in longrepr.splitlines():
             py.builtin.print_(" %s" % line, file=self.logfile)
 
diff --git a/python/pytest/_pytest/runner.py b/python/pytest/_pytest/runner.py
index cde94c8c89..d35b3f3232 100644
--- a/python/pytest/_pytest/runner.py
+++ b/python/pytest/_pytest/runner.py
@@ -159,8 +159,8 @@ class CallInfo:
         if self.excinfo:
             status = "exception: %s" % str(self.excinfo.value)
         else:
-            status = "result: %r" % (self.result,)
-        return "<CallInfo when=%r %s>" % (self.when, status)
+            status = "result: {!r}".format(self.result)
+        return "<CallInfo when={!r} {}>".format(self.when, status)
 
 def getslaveinfoline(node):
     try:
@@ -168,11 +168,11 @@ def getslaveinfoline(node):
     except AttributeError:
         d = node.slaveinfo
         ver = "%s.%s.%s" % d['version_info'][:3]
-        node._slaveinfocache = s = "[%s] %s -- Python %s %s" % (
+        node._slaveinfocache = s = "[{}] {} -- Python {} {}".format(
             d['id'], d['sysplatform'], ver, d['executable'])
         return s
 
-class BaseReport(object):
+class BaseReport:
 
     def __init__(self, **kw):
         self.__dict__.update(kw)
@@ -209,7 +209,7 @@ class BaseReport(object):
 def pytest_runtest_makereport(item, call):
     when = call.when
     duration = call.stop-call.start
-    keywords = dict([(x,1) for x in item.keywords])
+    keywords = {x:1 for x in item.keywords}
     excinfo = call.excinfo
     sections = []
     if not call.excinfo:
@@ -273,7 +273,7 @@ class TestReport(BaseReport):
         self.__dict__.update(extra)
 
     def __repr__(self):
-        return "<TestReport %r when=%r outcome=%r>" % (
+        return "<TestReport {!r} when={!r} outcome={!r}>".format(
             self.nodeid, self.when, self.outcome)
 
 class TeardownErrorReport(BaseReport):
@@ -323,7 +323,7 @@ class CollectReport(BaseReport):
         return (self.fspath, None, self.fspath)
 
     def __repr__(self):
-        return "<CollectReport %r lenresult=%s outcome=%r>" % (
+        return "<CollectReport {!r} lenresult={} outcome={!r}>".format(
                 self.nodeid, len(self.result), self.outcome)
 
 class CollectErrorRepr(TerminalRepr):
@@ -332,7 +332,7 @@ class CollectErrorRepr(TerminalRepr):
     def toterminal(self, out):
         out.line(self.longrepr, red=True)
 
-class SetupState(object):
+class SetupState:
     """ shared state for setting up/tearing down test items or collectors. """
     def __init__(self):
         self.stack = []
diff --git a/python/pytest/_pytest/skipping.py b/python/pytest/_pytest/skipping.py
index 18e038d2c8..0ef3cad1b1 100644
--- a/python/pytest/_pytest/skipping.py
+++ b/python/pytest/_pytest/skipping.py
@@ -112,7 +112,7 @@ class MarkEvaluator:
         try:
             d.update(func.__globals__)
         except AttributeError:
-            d.update(func.func_globals)
+            d.update(func.__globals__)
         return d
 
     def _istrue(self):
@@ -307,7 +307,7 @@ def show_xfailed(terminalreporter, lines):
         for rep in xfailed:
             pos = terminalreporter.config.cwd_relative_nodeid(rep.nodeid)
             reason = rep.wasxfail
-            lines.append("XFAIL %s" % (pos,))
+            lines.append("XFAIL {}".format(pos))
             if reason:
                 lines.append("  " + str(reason))
 
diff --git a/python/pytest/_pytest/standalonetemplate.py b/python/pytest/_pytest/standalonetemplate.py
index 484d5d1b25..13e4fcca1d 100755
--- a/python/pytest/_pytest/standalonetemplate.py
+++ b/python/pytest/_pytest/standalonetemplate.py
@@ -26,7 +26,7 @@ import sys
 import base64
 import zlib
 
-class DictImporter(object):
+class DictImporter:
     def __init__(self, sources):
         self.sources = sources
 
@@ -53,7 +53,7 @@ class DictImporter(object):
 
         co = compile(s, fullname, 'exec')
         module = sys.modules.setdefault(fullname, ModuleType(fullname))
-        module.__file__ = "%s/%s" % (__file__, fullname)
+        module.__file__ = "{}/{}".format(__file__, fullname)
         module.__loader__ = self
         if is_pkg:
             module.__path__ = [fullname]
@@ -73,15 +73,10 @@ if __name__ == "__main__":
     except ImportError:
         sys.stderr.write("ERROR: setuptools not installed\n")
         sys.exit(2)
-    if sys.version_info >= (3, 0):
-        exec("def do_exec(co, loc): exec(co, loc)\n")
-        import pickle
-        sources = sources.encode("ascii") # ensure bytes
-        sources = pickle.loads(zlib.decompress(base64.decodebytes(sources)))
-    else:
-        import cPickle as pickle
-        exec("def do_exec(co, loc): exec co in loc\n")
-        sources = pickle.loads(zlib.decompress(base64.decodestring(sources)))
+    exec("def do_exec(co, loc): exec(co, loc)\n")
+    import pickle
+    sources = sources.encode("ascii") # ensure bytes
+    sources = pickle.loads(zlib.decompress(base64.decodebytes(sources)))
 
     importer = DictImporter(sources)
     sys.meta_path.insert(0, importer)
diff --git a/python/pytest/_pytest/terminal.py b/python/pytest/_pytest/terminal.py
index 825f553ef2..113d6dd6b8 100644
--- a/python/pytest/_pytest/terminal.py
+++ b/python/pytest/_pytest/terminal.py
@@ -179,7 +179,7 @@ class TerminalReporter:
 
     def pytest_plugin_registered(self, plugin):
         if self.config.option.traceconfig:
-            msg = "PLUGIN registered: %s" % (plugin,)
+            msg = "PLUGIN registered: {}".format(plugin)
             # XXX this event may happen during setup/teardown time
             #     which unfortunately captures our output here
             #     which garbles our output if we use self.write_line
@@ -281,11 +281,11 @@ class TerminalReporter:
             return
         self.write_sep("=", "test session starts", bold=True)
         verinfo = platform.python_version()
-        msg = "platform %s -- Python %s" % (sys.platform, verinfo)
+        msg = "platform {} -- Python {}".format(sys.platform, verinfo)
         if hasattr(sys, 'pypy_version_info'):
             verinfo = ".".join(map(str, sys.pypy_version_info[:3]))
-            msg += "[pypy-%s-%s]" % (verinfo, sys.pypy_version_info[3])
-        msg += ", pytest-%s, py-%s, pluggy-%s" % (
+            msg += "[pypy-{}-{}]".format(verinfo, sys.pypy_version_info[3])
+        msg += ", pytest-{}, py-{}, pluggy-{}".format(
                pytest.__version__, py.__version__, pluggy.__version__)
         if self.verbosity > 0 or self.config.option.debug or \
            getattr(self.config.option, 'pastebin', None):
@@ -355,7 +355,7 @@ class TerminalReporter:
                 #if col.name == "()":
                 #    continue
                 indent = (len(stack) - 1) * "  "
-                self._tw.line("%s%s" % (indent, col))
+                self._tw.line("{}{}".format(indent, col))
 
     @pytest.hookimpl(hookwrapper=True)
     def pytest_sessionfinish(self, exitstatus):
@@ -447,7 +447,7 @@ class TerminalReporter:
                 return
             self.write_sep("=", "pytest-warning summary")
             for w in warnings:
-                self._tw.line("W%s %s %s" % (w.code,
+                self._tw.line("W{} {} {}".format(w.code,
                               w.fslocation, w.message))
 
     def summary_passes(self):
@@ -507,7 +507,7 @@ class TerminalReporter:
     def summary_stats(self):
         session_duration = time.time() - self._sessionstarttime
         (line, color) = build_summary_stats_line(self.stats)
-        msg = "%s in %.2f seconds" % (line, session_duration)
+        msg = "{} in {:.2f} seconds".format(line, session_duration)
         markup = {color: True, 'bold': True}
 
         if self.verbosity >= 0:
@@ -539,8 +539,7 @@ def repr_pythonversion(v=None):
 def flatten(l):
     for x in l:
         if isinstance(x, (list, tuple)):
-            for y in flatten(x):
-                yield y
+            yield from flatten(x)
         else:
             yield x
 
diff --git a/python/pytest/_pytest/tmpdir.py b/python/pytest/_pytest/tmpdir.py
index ebc48dbe5b..594cd8bbbb 100644
--- a/python/pytest/_pytest/tmpdir.py
+++ b/python/pytest/_pytest/tmpdir.py
@@ -115,7 +115,7 @@ def tmpdir(request, tmpdir_factory):
     path object.
     """
     name = request.node.name
-    name = re.sub("[\W]", "_", name)
+    name = re.sub(r"[\W]", "_", name)
     MAXVAL = 30
     if len(name) > MAXVAL:
         name = name[:MAXVAL]
diff --git a/python/pytest/_pytest/unittest.py b/python/pytest/_pytest/unittest.py
index 8120e94fbf..1880581e75 100644
--- a/python/pytest/_pytest/unittest.py
+++ b/python/pytest/_pytest/unittest.py
@@ -1,5 +1,4 @@
 """ discovery and running of std-library "unittest" style tests. """
-from __future__ import absolute_import
 
 import sys
 import traceback
@@ -37,10 +36,10 @@ class UnitTestCase(pytest.Class):
         teardown = getattr(cls, 'tearDownClass', None)
         if teardown is not None:
             self.addfinalizer(teardown)
-        super(UnitTestCase, self).setup()
+        super().setup()
 
     def collect(self):
-        from unittest import TestLoader
+        from .unittest import TestLoader
         cls = self.obj
         if not getattr(cls, "__test__", True):
             return
diff --git a/python/pytest/_pytest/vendored_packages/pluggy.py b/python/pytest/_pytest/vendored_packages/pluggy.py
index 2f848b23d3..659bad8ec9 100644
--- a/python/pytest/_pytest/vendored_packages/pluggy.py
+++ b/python/pytest/_pytest/vendored_packages/pluggy.py
@@ -186,11 +186,11 @@ class _TagTracer:
         indent = "  " * self.indent
 
         lines = [
-            "%s%s [%s]\n" % (indent, content, ":".join(tags))
+            "{}{} [{}]\n".format(indent, content, ":".join(tags))
         ]
 
         for name, value in extra.items():
-            lines.append("%s    %s: %s\n" % (indent, name, value))
+            lines.append("{}    {}: {}\n".format(indent, name, value))
         return lines
 
     def processmessage(self, tags, args):
@@ -281,7 +281,7 @@ class _CallOutcome:
 if not _py3:
     exec("""
 def _reraise(cls, val, tb):
-    raise cls, val, tb
+    raise cls(val, tb)
 """)
 
 
@@ -304,7 +304,7 @@ class _TracedHookExecution:
         self.pluginmanager._inner_hookexec = self.oldcall
 
 
-class PluginManager(object):
+class PluginManager:
     """ Core Pluginmanager class which manages registration
     of plugin objects and 1:N hook calling.
 
@@ -606,7 +606,7 @@ class _MultiCall:
         status = "%d meths" % (len(self.hook_impls),)
         if hasattr(self, "results"):
             status = ("%d results, " % len(self.results)) + status
-        return "<_MultiCall %s, kwargs=%r>" % (status, self.kwargs)
+        return "<_MultiCall {}, kwargs={!r}>".format(status, self.kwargs)
 
 
 def varnames(func, startindex=None):
@@ -662,7 +662,7 @@ class _HookRelay:
         self._trace = trace
 
 
-class _HookCaller(object):
+class _HookCaller:
     def __init__(self, name, hook_execute, specmodule_or_class=None, spec_opts=None):
         self.name = name
         self._wrappers = []
@@ -697,7 +697,7 @@ class _HookCaller(object):
                     return True
         if remove(self._wrappers) is None:
             if remove(self._nonwrappers) is None:
-                raise ValueError("plugin %r not found" % (plugin,))
+                raise ValueError("plugin {!r} not found".format(plugin))
 
     def _add_hookimpl(self, hookimpl):
         if hookimpl.hookwrapper:
@@ -717,7 +717,7 @@ class _HookCaller(object):
             methods.insert(i + 1, hookimpl)
 
     def __repr__(self):
-        return "<_HookCaller %r>" % (self.name,)
+        return "<_HookCaller {!r}>".format(self.name)
 
     def __call__(self, **kwargs):
         assert not self.is_historic()
@@ -765,13 +765,13 @@ class PluginValidationError(Exception):
 
 if hasattr(inspect, 'signature'):
     def _formatdef(func):
-        return "%s%s" % (
+        return "{}{}".format(
             func.__name__,
             str(inspect.signature(func))
         )
 else:
     def _formatdef(func):
-        return "%s%s" % (
+        return "{}{}".format(
             func.__name__,
             inspect.formatargspec(*inspect.getargspec(func))
         )
diff --git a/python/pytest/setup.py b/python/pytest/setup.py
index 7cdcdfb992..af5b95228d 100644
--- a/python/pytest/setup.py
+++ b/python/pytest/setup.py
@@ -99,7 +99,7 @@ def make_entry_points():
     points = cmdline_entrypoints(sys.version_info, sys.platform, basename)
     keys = list(points.keys())
     keys.sort()
-    l = ['%s = %s' % (x, points[x]) for x in keys]
+    l = ['{} = {}'.format(x, points[x]) for x in keys]
     return {'console_scripts': l}
 
 
diff --git a/python/pyyaml/examples/pygments-lexer/yaml.py b/python/pyyaml/examples/pygments-lexer/yaml.py
index 1ce9dac9e4..a2c91febda 100644
--- a/python/pyyaml/examples/pygments-lexer/yaml.py
+++ b/python/pyyaml/examples/pygments-lexer/yaml.py
@@ -1,4 +1,3 @@
-
 """
 yaml.py
 
@@ -22,7 +21,7 @@ class YAMLLexerContext(LexerContext):
     """Indentation context for the YAML lexer."""
 
     def __init__(self, *args, **kwds):
-        super(YAMLLexerContext, self).__init__(*args, **kwds)
+        super().__init__(*args, **kwds)
         self.indent_stack = []
         self.indent = -1
         self.next_indent = 0
@@ -426,6 +425,6 @@ class YAMLLexer(ExtendedRegexLexer):
     def get_tokens_unprocessed(self, text=None, context=None):
         if context is None:
             context = YAMLLexerContext(text, 0)
-        return super(YAMLLexer, self).get_tokens_unprocessed(text, context)
+        return super().get_tokens_unprocessed(text, context)
 
 
diff --git a/python/pyyaml/examples/yaml-highlight/yaml_hl.py b/python/pyyaml/examples/yaml-highlight/yaml_hl.py
index d6f7bf4eb2..8bc6520998 100755
--- a/python/pyyaml/examples/yaml-highlight/yaml_hl.py
+++ b/python/pyyaml/examples/yaml-highlight/yaml_hl.py
@@ -15,7 +15,7 @@ class Style:
                 continue
             for key in domain:
                 name = ''.join([part.capitalize() for part in key.split('-')])
-                cls = getattr(yaml, '%s%s' % (name, Class))
+                cls = getattr(yaml, '{}{}'.format(name, Class))
                 value = domain[key]
                 if not value:
                     continue
@@ -29,33 +29,33 @@ class Style:
     def __setstate__(self, state):
         self.__init__(**state)
 
-yaml.add_path_resolver(u'tag:yaml.org,2002:python/object:__main__.Style',
+yaml.add_path_resolver('tag:yaml.org,2002:python/object:__main__.Style',
         [None], dict)
-yaml.add_path_resolver(u'tag:yaml.org,2002:pairs',
-        [None, u'replaces'], list)
+yaml.add_path_resolver('tag:yaml.org,2002:pairs',
+        [None, 'replaces'], list)
 
 class YAMLHighlight:
 
     def __init__(self, options):
-        config = yaml.load(file(options.config, 'rb').read())
+        config = yaml.load(open(options.config, 'rb').read())
         self.style = config[options.style]
         if options.input:
-            self.input = file(options.input, 'rb')
+            self.input = open(options.input, 'rb')
         else:
             self.input = sys.stdin
         if options.output:
-            self.output = file(options.output, 'wb')
+            self.output = open(options.output, 'wb')
         else:
             self.output = sys.stdout
 
     def highlight(self):
         input = self.input.read()
         if input.startswith(codecs.BOM_UTF16_LE):
-            input = unicode(input, 'utf-16-le')
+            input = str(input, 'utf-16-le')
         elif input.startswith(codecs.BOM_UTF16_BE):
-            input = unicode(input, 'utf-16-be')
+            input = str(input, 'utf-16-be')
         else:
-            input = unicode(input, 'utf-8')
+            input = str(input, 'utf-8')
         substitutions = self.style.substitutions
         tokens = yaml.scan(input)
         events = yaml.parse(input)
@@ -90,7 +90,7 @@ class YAMLHighlight:
                 position = index
             chunks.append(substitution)
         chunks.reverse()
-        result = u''.join(chunks)
+        result = ''.join(chunks)
         if self.style.header:
             self.output.write(self.style.header)
         self.output.write(result.encode('utf-8'))
